-- The default rotations generator for DEATHKNIGHT.
local deathKnightRotationsGenerator = function ()
  local rotation = {
	["defaultRotation/deathknight/frost_dual_wielding"] = {
		["ActionList"] = {
			["defaultRotation/deathknight/frost_strike_killing_machine"] = {
				["v_gcdspell"] = "111673",
				["b_p_havebuff"] = true,
				["v_rangespell"] = "49020",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "49143",
				["v_actionicon"] = "49143",
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "51124",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/plague_leech"] = {
				["b_p_frostrunes"] = true,
				["b_p_bloodrunes"] = true,
				["b_t_hasdebuff"] = true,
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "123693",
				["b_p_unholyrunes"] = true,
				["v_p_bloodrunes"] = "<=1",
				["v_t_hasdebuff"] = "_55095^3||_152159^3",
				["v_p_knowspell"] = "123693",
				["b_p_knowspell"] = true,
				["v_p_unholyrunes"] = "<=1",
				["v_actionicon"] = "123693",
				["v_keybind"] = "<keybind>",
				["v_p_frostrunes"] = "<=1",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/howling_blast_frost_rune"] = {
				["b_p_frostrunes"] = true,
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "49184",
				["v_spellname"] = "49184",
				["v_p_frostrunes"] = ">=1",
				["v_keybind"] = "<keybind>",
				["v_durationstartedtime"] = 0,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/horn_of_winter"] = {
				["v_p_needbuff"] = "57330|19506|6673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "57330",
				["b_p_needbuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "57330",
			},
			["defaultRotation/deathknight/obliterate_killing_machine"] = {
				["v_actionicon"] = "49020",
				["b_p_havebuff"] = true,
				["v_gcdspell"] = "111673",
				["v_p_havebuff"] = "51124",
				["b_p_unitpower"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "49020",
				["v_p_unitpowertype"] = "6",
				["v_keybind"] = "<keybind>",
				["v_p_unitpower"] = "<40",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/frost_strike"] = {
				["v_actionicon"] = "49143",
				["v_rangespell"] = "49020",
				["b_p_unitpower"] = true,
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_p_unitpowertype"] = "6",
				["v_spellname"] = "49143",
				["v_durationstartedtime"] = 0,
				["v_keybind"] = "<keybind>",
				["v_p_unitpower"] = ">88",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/death_pact"] = {
				["v_p_knowspell"] = "48743",
				["v_gcdspell"] = "0",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "48743",
				["v_actionicon"] = "48743",
				["b_p_hp"] = true,
				["v_p_hp"] = "<35%",
				["v_keybind"] = "<keybind>",
			},
			["defaultRotation/deathknight/obliterate"] = {
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "49020",
				["v_p_unholyrunes"] = "=2",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "49020",
				["v_togglename"] = "Toggle 1",
				["v_keybind"] = "<keybind>",
				["b_p_unholyrunes"] = true,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/howling_blast"] = {
				["v_t_needsdebuff"] = "_55095^3||_152159^3",
				["v_actionicon"] = "49184",
				["v_gcdspell"] = "111673",
				["b_rangecheck"] = true,
				["b_checkothercd"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "49184",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_checkothercdvalue"] = ">5",
				["v_checkothercdname"] = "77575",
			},
			["defaultRotation/deathknight/howling_blast_freezing_fog"] = {
				["v_gcdspell"] = "111673",
				["b_p_havebuff"] = true,
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "49184",
				["v_spellname"] = "49184",
				["v_durationstartedtime"] = 0,
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "_59052",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/outbreak"] = {
				["v_t_needsdebuff"] = "_55095^3||_152159^3",
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "77575",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "77575",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/blood_tap"] = {
				["v_p_knowspell"] = "45529",
				["v_gcdspell"] = "0",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "45529",
				["v_spellname"] = "45529",
				["b_p_havebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "_114851#10",
				["v_durationstartedtime"] = 0,
			},
			["defaultRotation/deathknight/howling_blast_death_rune"] = {
				["v_p_deathrunes"] = ">=1",
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "49184",
				["v_spellname"] = "49184",
				["v_durationstartedtime"] = 0,
				["v_keybind"] = "<keybind>",
				["b_p_deathrunes"] = true,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/soul_reaper"] = {
				["v_gcdspell"] = "111673",
				["v_t_hp"] = "<35%",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "114866",
				["b_t_hp"] = true,
				["v_spellname"] = "114866",
				["v_keybind"] = "<keybind>",
				["v_durationstartedtime"] = 0,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/plague_strike"] = {
				["v_t_needsdebuff"] = "_55078^3",
				["v_actionicon"] = "45462",
				["b_rangecheck"] = true,
				["v_togglename"] = "Toggle 1",
				["b_p_knownotspell"] = true,
				["v_p_knownotspell"] = "152281",
				["v_gcdspell"] = "111673",
				["b_p_unholyrunes"] = true,
				["b_checkothercd"] = true,
				["v_p_unholyrunes"] = ">=1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "45462",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_checkothercdvalue"] = ">5",
				["v_checkothercdname"] = "77575",
			},
			["defaultRotation/deathknight/defile"] = {
				["v_p_knowspell"] = "152280",
				["v_gcdspell"] = "111673",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "43265",
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "152280",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/pillar_of_frost"] = {
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "51271",
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "0",
				["v_actionicon"] = "51271",
			},
			["defaultRotation/deathknight/frost_presence"] = {
				["v_p_needbuff"] = "48266",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "48266",
				["b_p_needbuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "48266",
			},
		},
		["SortedActions"] = {
			"defaultRotation/deathknight/frost_presence", -- [1]
			"defaultRotation/deathknight/horn_of_winter", -- [2]
			"defaultRotation/deathknight/death_pact", -- [3]
			"defaultRotation/deathknight/pillar_of_frost", -- [4]
			"defaultRotation/deathknight/blood_tap", -- [5]
			"defaultRotation/deathknight/plague_leech", -- [6]
			"defaultRotation/deathknight/soul_reaper", -- [7]
			"defaultRotation/deathknight/frost_strike_killing_machine", -- [8]
			"defaultRotation/deathknight/obliterate_killing_machine", -- [9]
			"defaultRotation/deathknight/obliterate", -- [10]
			"defaultRotation/deathknight/defile", -- [11]
			"defaultRotation/deathknight/frost_strike", -- [12]
			"defaultRotation/deathknight/howling_blast_freezing_fog", -- [13]
			"defaultRotation/deathknight/howling_blast_frost_rune", -- [14]
			"defaultRotation/deathknight/howling_blast_death_rune", -- [15]
			"defaultRotation/deathknight/outbreak", -- [16]
			"defaultRotation/deathknight/howling_blast", -- [17]
			"defaultRotation/deathknight/plague_strike", -- [18]
		},
		["keybind"] = "<keybind>",
	},
	["defaultRotation/deathknight/frost"] = {
		["ActionList"] = {
			["defaultRotation/deathknight/outbreak"] = {
				["v_t_needsdebuff"] = "_55095^3||_152159^3",
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "77575",
				["v_spellname"] = "77575",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_durationstartedtime"] = 0,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/frost_presence"] = {
				["v_p_needbuff"] = "48266",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "48266",
				["b_p_needbuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "48266",
			},
			["defaultRotation/deathknight/blood_tap"] = {
				["v_p_knowspell"] = "45529",
				["v_gcdspell"] = "0",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["b_p_havebuff"] = true,
				["v_spellname"] = "45529",
				["v_actionicon"] = "45529",
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "_114851#10",
				["v_durationstartedtime"] = 0,
			},
			["defaultRotation/deathknight/pillar_of_frost"] = {
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "51271",
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "0",
				["v_actionicon"] = "51271",
			},
			["defaultRotation/deathknight/plague_leech"] = {
				["b_p_frostrunes"] = true,
				["b_p_bloodrunes"] = true,
				["b_t_hasdebuff"] = true,
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "123693",
				["v_p_frostrunes"] = "<=1",
				["v_p_bloodrunes"] = "<=1",
				["v_t_hasdebuff"] = "_55095^3||_152159^3",
				["v_p_knowspell"] = "123693",
				["b_p_knowspell"] = true,
				["v_p_unholyrunes"] = "<=1",
				["v_actionicon"] = "123693",
				["v_keybind"] = "<keybind>",
				["b_p_unholyrunes"] = true,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/obliterate_killing_machine"] = {
				["v_gcdspell"] = "111673",
				["b_p_havebuff"] = true,
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "49020",
				["v_spellname"] = "49020",
				["v_durationstartedtime"] = 0,
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "51124",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/death_pact"] = {
				["v_p_knowspell"] = "48743",
				["v_gcdspell"] = "0",
				["b_p_knowspell"] = true,
				["v_p_hp"] = "<35%",
				["v_actionicon"] = "48743",
				["v_spellname"] = "48743",
				["v_keybind"] = "<keybind>",
				["b_p_hp"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
			},
			["defaultRotation/deathknight/frost_strike_runic_power"] = {
				["v_actionicon"] = "49143",
				["v_gcdspell"] = "111673",
				["b_p_unitpower"] = true,
				["v_durationstartedtime"] = 0,
				["v_togglename"] = "Toggle 1",
				["v_p_unitpowertype"] = "6",
				["v_spellname"] = "49143",
				["v_rangespell"] = "49020",
				["v_keybind"] = "<keybind>",
				["v_p_unitpower"] = ">76",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/soul_reaper"] = {
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "114866",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "114866",
				["b_rangecheck"] = true,
				["v_keybind"] = "<keybind>",
				["b_t_hp"] = true,
				["v_t_hp"] = "<35%",
			},
			["defaultRotation/deathknight/frost_strike"] = {
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "49143",
				["v_actionicon"] = "49143",
				["v_keybind"] = "<keybind>",
				["v_rangespell"] = "49020",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/plague_strike"] = {
				["v_t_needsdebuff"] = "_55078^3",
				["b_p_unholyrunes"] = true,
				["b_p_knownotspell"] = true,
				["v_p_knownotspell"] = "152281",
				["v_togglename"] = "Toggle 1",
				["b_rangecheck"] = true,
				["v_gcdspell"] = "111673",
				["v_keybind"] = "<keybind>",
				["b_checkothercd"] = true,
				["v_p_unholyrunes"] = ">=1",
				["v_actionicon"] = "45462",
				["v_spellname"] = "45462",
				["b_t_needsdebuff"] = true,
				["v_checkothercdvalue"] = ">5",
				["v_durationstartedtime"] = 0,
				["v_checkothercdname"] = "77575",
			},
			["defaultRotation/deathknight/defile"] = {
				["v_p_knowspell"] = "152280",
				["v_gcdspell"] = "111673",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "152280",
				["v_spellname"] = "43265",
				["v_keybind"] = "<keybind>",
				["v_durationstartedtime"] = 0,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/obliterate"] = {
				["b_p_frostrunes"] = true,
				["v_gcdspell"] = "111673",
				["v_p_frostrunes"] = ">=1",
				["b_p_unholyrunes"] = true,
				["v_p_unholyrunes"] = ">=1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "49020",
				["v_togglename"] = "Toggle 1",
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "49020",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/howling_blast"] = {
				["v_t_needsdebuff"] = "_55095^3||_152159^3",
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["b_rangecheck"] = true,
				["b_checkothercd"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "49184",
				["b_t_needsdebuff"] = true,
				["v_checkothercdvalue"] = ">5",
				["v_actionicon"] = "49184",
				["v_checkothercdname"] = "77575",
			},
			["defaultRotation/deathknight/horn_of_winter"] = {
				["v_p_needbuff"] = "57330|19506|6673",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "57330",
				["v_spellname"] = "57330",
				["b_p_needbuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["v_durationstartedtime"] = 0,
			},
			["defaultRotation/deathknight/howling_blast_freezing_fog"] = {
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "49184",
				["v_togglename"] = "Toggle 1",
				["b_p_havebuff"] = true,
				["v_spellname"] = "49184",
				["v_durationstartedtime"] = 0,
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "_59052",
				["b_rangecheck"] = true,
			},
		},
		["SortedActions"] = {
			"defaultRotation/deathknight/frost_presence", -- [1]
			"defaultRotation/deathknight/horn_of_winter", -- [2]
			"defaultRotation/deathknight/death_pact", -- [3]
			"defaultRotation/deathknight/pillar_of_frost", -- [4]
			"defaultRotation/deathknight/blood_tap", -- [5]
			"defaultRotation/deathknight/plague_leech", -- [6]
			"defaultRotation/deathknight/soul_reaper", -- [7]
			"defaultRotation/deathknight/defile", -- [8]
			"defaultRotation/deathknight/obliterate_killing_machine", -- [9]
			"defaultRotation/deathknight/howling_blast_freezing_fog", -- [10]
			"defaultRotation/deathknight/outbreak", -- [11]
			"defaultRotation/deathknight/howling_blast", -- [12]
			"defaultRotation/deathknight/plague_strike", -- [13]
			"defaultRotation/deathknight/frost_strike_runic_power", -- [14]
			"defaultRotation/deathknight/obliterate", -- [15]
			"defaultRotation/deathknight/frost_strike", -- [16]
		},
		["keybind"] = "<keybind>",
	},
	["defaultRotation/deathknight/unholy"] = {
		["ActionList"] = {
			["defaultRotation/deathknight/festering_strike_blood_rune"] = {
				["b_p_bloodrunes"] = true,
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "85948",
				["v_actionicon"] = "85948",
				["v_keybind"] = "<keybind>",
				["v_p_bloodrunes"] = "=2",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/summon_gargoyle"] = {
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "49206",
				["v_actionicon"] = "49206",
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/scourge_strike"] = {
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "55090",
				["v_p_unholyrunes"] = ">=1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "55090",
				["v_togglename"] = "Toggle 1",
				["v_keybind"] = "<keybind>",
				["b_p_unholyrunes"] = true,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/festering_strike_frost_rune"] = {
				["b_p_frostrunes"] = true,
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "85948",
				["v_actionicon"] = "85948",
				["v_keybind"] = "<keybind>",
				["v_p_frostrunes"] = "=2",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/scourge_strike_death_rune"] = {
				["v_p_deathrunes"] = ">=1",
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "55090",
				["v_spellname"] = "55090",
				["v_durationstartedtime"] = 0,
				["v_keybind"] = "<keybind>",
				["b_p_deathrunes"] = true,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/death_pact"] = {
				["v_p_knowspell"] = "48743",
				["v_gcdspell"] = "0",
				["b_p_knowspell"] = true,
				["v_p_hp"] = "<35%",
				["v_actionicon"] = "48743",
				["v_spellname"] = "48743",
				["v_keybind"] = "<keybind>",
				["b_p_hp"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
			},
			["defaultRotation/deathknight/plague_leech_diseases"] = {
				["v_t_needsdebuff"] = "_55095^3||_152159^3",
				["v_p_knowspell"] = "123693",
				["v_gcdspell"] = "111673",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "123693",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "123693",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/outbreak"] = {
				["v_t_needsdebuff"] = "_55095^3||_152159^3",
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "77575",
				["v_spellname"] = "77575",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_durationstartedtime"] = 0,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/unholy_blight"] = {
				["v_t_needsdebuff"] = "_155159#15^3",
				["v_p_knowspell"] = "115989&152281",
				["v_gcdspell"] = "111673",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "115989",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "115989",
				["b_t_dr"] = true,
			},
			["defaultRotation/deathknight/blood_tap"] = {
				["v_p_knowspell"] = "45529",
				["v_gcdspell"] = "0",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "45529",
				["v_actionicon"] = "45529",
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "_114851#10",
				["b_p_havebuff"] = true,
			},
			["defaultRotation/deathknight/plague_leech"] = {
				["b_p_frostrunes"] = true,
				["b_p_bloodrunes"] = true,
				["b_t_hasdebuff"] = true,
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "123693",
				["v_checkothercdvalue"] = "<=1",
				["v_p_bloodrunes"] = "<=1",
				["v_t_hasdebuff"] = "_55095^3||_152159^3",
				["v_p_knowspell"] = "123693",
				["b_rangecheck"] = true,
				["b_checkothercd"] = true,
				["v_p_unholyrunes"] = "<=1",
				["v_actionicon"] = "123693",
				["b_p_unholyrunes"] = true,
				["v_checkothercdname"] = "77575",
				["v_keybind"] = "<keybind>",
				["v_p_frostrunes"] = "<=1",
				["b_p_knowspell"] = true,
			},
			["defaultRotation/deathknight/death_coil_runic_power"] = {
				["v_gcdspell"] = "111673",
				["v_p_unitpowertype"] = "6",
				["v_durationstartedtime"] = 0,
				["v_togglename"] = "Toggle 1",
				["b_p_unitpower"] = true,
				["v_spellname"] = "47541",
				["v_actionicon"] = "47541",
				["v_keybind"] = "<keybind>",
				["v_p_unitpower"] = ">80",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/death_coil"] = {
				["v_p_needbuff"] = "63560",
				["b_p_needbuff"] = true,
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "47541",
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "47541",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/festering_strike"] = {
				["v_t_needsdebuff"] = "_155159^3",
				["v_p_knowspell"] = "152281",
				["v_gcdspell"] = "111673",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "85948",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "85948",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/unholy_presence"] = {
				["v_p_needbuff"] = "48265",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "48265",
				["b_p_needbuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "48265",
			},
			["defaultRotation/deathknight/soul_reaper"] = {
				["v_gcdspell"] = "111673",
				["v_t_hp"] = "<45%",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "114866",
				["v_actionicon"] = "114866",
				["v_keybind"] = "<keybind>",
				["b_t_hp"] = true,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/raise_dead"] = {
				["v_actionicon"] = "46584",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_pet_hp"] = "=0",
				["v_spellname"] = "46584",
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["b_pet_hp"] = true,
			},
			["defaultRotation/deathknight/plague_strike"] = {
				["v_t_needsdebuff"] = "_55095^3||_152159^3",
				["v_actionicon"] = "45462",
				["v_gcdspell"] = "111673",
				["b_rangecheck"] = true,
				["b_checkothercd"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "45462",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_checkothercdvalue"] = ">5",
				["v_checkothercdname"] = "77575",
			},
			["defaultRotation/deathknight/defile"] = {
				["v_p_knowspell"] = "152280",
				["v_gcdspell"] = "111673",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "43265",
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "152280",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/dark_transformation"] = {
				["v_pet_hasbuff"] = "91342#5",
				["b_pet_hasbuff"] = true,
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "63560",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "63560",
				["b_p_havebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "91342#5",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/breath_of_sindragosa"] = {
				["v_actionicon"] = "152279",
				["b_p_frostrunes"] = true,
				["b_p_bloodrunes"] = true,
				["v_durationstartedtime"] = 0,
				["v_togglename"] = "Toggle 1",
				["v_p_unitpower"] = ">75",
				["v_gcdspell"] = "111673",
				["b_p_unholyrunes"] = true,
				["v_p_frostrunes"] = ">=1",
				["v_p_unholyrunes"] = ">=1",
				["v_p_unitpowertype"] = "6",
				["v_spellname"] = "152279",
				["b_p_unitpower"] = true,
				["v_keybind"] = "<keybind>",
				["v_p_bloodrunes"] = ">=1",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/horn_of_winter"] = {
				["v_p_needbuff"] = "57330|19506|6673",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "57330",
				["b_p_needbuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "57330",
			},
			["defaultRotation/deathknight/death_coil_sudden_doom"] = {
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "47541",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "47541",
				["b_p_havebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "81340",
				["b_rangecheck"] = true,
			},
		},
		["SortedActions"] = {
			"defaultRotation/deathknight/unholy_presence", -- [1]
			"defaultRotation/deathknight/horn_of_winter", -- [2]
			"defaultRotation/deathknight/raise_dead", -- [3]
			"defaultRotation/deathknight/death_pact", -- [4]
			"defaultRotation/deathknight/summon_gargoyle", -- [5]
			"defaultRotation/deathknight/dark_transformation", -- [6]
			"defaultRotation/deathknight/unholy_blight", -- [7]
			"defaultRotation/deathknight/breath_of_sindragosa", -- [8]
			"defaultRotation/deathknight/plague_leech_diseases", -- [9]
			"defaultRotation/deathknight/plague_leech", -- [10]
			"defaultRotation/deathknight/soul_reaper", -- [11]
			"defaultRotation/deathknight/defile", -- [12]
			"defaultRotation/deathknight/outbreak", -- [13]
			"defaultRotation/deathknight/plague_strike", -- [14]
			"defaultRotation/deathknight/festering_strike_blood_rune", -- [15]
			"defaultRotation/deathknight/festering_strike_frost_rune", -- [16]
			"defaultRotation/deathknight/festering_strike", -- [17]
			"defaultRotation/deathknight/scourge_strike_death_rune", -- [18]
			"defaultRotation/deathknight/scourge_strike", -- [19]
			"defaultRotation/deathknight/blood_tap", -- [20]
			"defaultRotation/deathknight/death_coil_sudden_doom", -- [21]
			"defaultRotation/deathknight/death_coil_runic_power", -- [22]
			"defaultRotation/deathknight/death_coil", -- [23]
		},
		["keybind"] = "<keybind>",
	},
	["defaultRotation/deathknight/blood"] = {
		["ActionList"] = {
			["defaultRotation/deathknight/blood_boil_refresh_runic_empowerment"] = {
				["v_t_needsdebuff"] = "_55095^3||_152159^3",
				["b_p_bloodrunes"] = true,
				["v_p_knowspell"] = "81229",
				["v_gcdspell"] = "111673",
				["v_actionicon"] = "50842",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "50842",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_p_bloodrunes"] = "=2",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/dancing_rune_weapon"] = {
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "49028",
				["v_actionicon"] = "49028",
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/blood_boil_refresh"] = {
				["v_t_needsdebuff"] = "_55095^3||_152159^3",
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["b_p_knownotspell"] = true,
				["v_p_knownotspell"] = "81229",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "50842",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "50842",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/horn_of_winter"] = {
				["v_p_needbuff"] = "57330|19506|6673",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "57330",
				["v_spellname"] = "57330",
				["b_p_needbuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["v_durationstartedtime"] = 0,
			},
			["defaultRotation/deathknight/blood_tap_blood_rune"] = {
				["v_p_deathrunes"] = "=0",
				["b_p_bloodrunes"] = true,
				["v_p_knowspell"] = "45529",
				["v_actionicon"] = "45529",
				["b_p_deathrunes"] = true,
				["v_p_havebuff"] = "_114851#5",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "45529",
				["v_gcdspell"] = "0",
				["v_keybind"] = "<keybind>",
				["v_p_bloodrunes"] = "=0",
				["b_p_havebuff"] = true,
			},
			["defaultRotation/deathknight/death_pact"] = {
				["v_p_knowspell"] = "48743",
				["v_gcdspell"] = "0",
				["b_p_knowspell"] = true,
				["v_p_hp"] = "<35%",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "48743",
				["v_togglename"] = "Toggle 1",
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "48743",
				["b_p_hp"] = true,
			},
			["defaultRotation/deathknight/blood_presence"] = {
				["v_p_needbuff"] = "48263",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "48263",
				["v_spellname"] = "48263",
				["b_p_needbuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["v_durationstartedtime"] = 0,
			},
			["defaultRotation/deathknight/outbreak"] = {
				["v_t_needsdebuff"] = "_55095&_55078",
				["v_gcdspell"] = "111673",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "77575",
				["v_spellname"] = "77575",
				["b_t_needsdebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_durationstartedtime"] = 0,
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/blood_tap_unholy_rune"] = {
				["v_p_deathrunes"] = "=0",
				["v_actionicon"] = "45529",
				["v_p_knowspell"] = "45529",
				["b_p_havebuff"] = true,
				["v_gcdspell"] = "0",
				["b_p_unholyrunes"] = true,
				["b_p_knowspell"] = true,
				["v_p_unholyrunes"] = "=0",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "45529",
				["v_togglename"] = "Toggle 1",
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "_114851#5",
				["b_p_deathrunes"] = true,
			},
			["defaultRotation/deathknight/blood_boil_runic_empowerment"] = {
				["b_p_bloodrunes"] = true,
				["v_p_knowspell"] = "81229",
				["v_actionicon"] = "50842",
				["v_gcdspell"] = "111673",
				["v_spellname"] = "50842",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["b_t_hp"] = true,
				["v_t_hp"] = ">35%",
				["v_keybind"] = "<keybind>",
				["v_p_bloodrunes"] = "=2",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/blood_boil"] = {
				["b_p_bloodrunes"] = true,
				["v_actionicon"] = "50842",
				["b_rangecheck"] = true,
				["v_gcdspell"] = "111673",
				["b_p_knownotspell"] = true,
				["v_p_knownotspell"] = "81229",
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "50842",
				["b_t_hp"] = true,
				["v_keybind"] = "<keybind>",
				["v_p_bloodrunes"] = ">=1",
				["v_t_hp"] = ">35%",
			},
			["defaultRotation/deathknight/vampiric_blood"] = {
				["v_keybind"] = "<keybind>",
				["v_p_hp"] = "<50%",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "55233",
				["v_togglename"] = "Toggle 1",
				["b_p_hp"] = true,
				["v_gcdspell"] = "0",
				["v_actionicon"] = "55233",
			},
			["defaultRotation/deathknight/death_coil"] = {
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "47541",
				["v_actionicon"] = "47541",
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/soul_reaper"] = {
				["b_p_bloodrunes"] = true,
				["b_rangecheck"] = true,
				["v_togglename"] = "Toggle 1",
				["v_gcdspell"] = "111673",
				["b_p_knownotspell"] = true,
				["v_actionicon"] = "114866",
				["v_p_knownotspell"] = "81229",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "114866",
				["b_t_hp"] = true,
				["v_keybind"] = "<keybind>",
				["v_p_bloodrunes"] = ">=1",
				["v_t_hp"] = "<35%",
			},
			["defaultRotation/deathknight/blood_boil_crimson_scourge"] = {
				["v_actionicon"] = "50842",
				["v_gcdspell"] = "111673",
				["b_rangecheck"] = true,
				["b_t_hp"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "50842",
				["b_p_havebuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "81141",
				["v_t_hp"] = ">35%",
			},
			["defaultRotation/deathknight/death_strike"] = {
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "49998",
				["v_spellname"] = "49998",
				["v_durationstartedtime"] = 0,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "111673",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/defile"] = {
				["v_p_knowspell"] = "152280",
				["v_gcdspell"] = "111673",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "43265",
				["v_keybind"] = "<keybind>",
				["v_actionicon"] = "152280",
				["b_rangecheck"] = true,
			},
			["defaultRotation/deathknight/blood_tap_frost_rune"] = {
				["b_p_frostrunes"] = true,
				["v_p_deathrunes"] = "=0",
				["v_p_knowspell"] = "45529",
				["b_p_havebuff"] = true,
				["b_p_deathrunes"] = true,
				["v_gcdspell"] = "0",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "45529",
				["v_p_frostrunes"] = "=0",
				["v_keybind"] = "<keybind>",
				["v_p_havebuff"] = "_114851#5",
				["v_actionicon"] = "45529",
			},
			["defaultRotation/deathknight/bone_shield"] = {
				["v_p_needbuff"] = "_49222",
				["v_togglename"] = "Toggle 1",
				["v_actionicon"] = "49222",
				["v_spellname"] = "49222",
				["b_p_needbuff"] = true,
				["v_keybind"] = "<keybind>",
				["v_gcdspell"] = "0",
				["v_durationstartedtime"] = 0,
			},
			["defaultRotation/deathknight/plague_leech"] = {
				["b_p_frostrunes"] = true,
				["v_actionicon"] = "123693",
				["b_t_hasdebuff"] = true,
				["v_p_knowspell"] = "123693",
				["b_rangecheck"] = true,
				["v_gcdspell"] = "111673",
				["b_p_unholyrunes"] = true,
				["b_p_knowspell"] = true,
				["v_p_unholyrunes"] = "=0",
				["v_durationstartedtime"] = 0,
				["v_spellname"] = "123693",
				["v_togglename"] = "Toggle 1",
				["v_keybind"] = "<keybind>",
				["v_p_frostrunes"] = "=0",
				["v_t_hasdebuff"] = "_55095^3||_152159^3",
			},
			["defaultRotation/deathknight/soul_reaper_runic_empowerment"] = {
				["b_p_bloodrunes"] = true,
				["v_p_knowspell"] = "81229",
				["v_actionicon"] = "114866",
				["v_gcdspell"] = "111673",
				["v_t_hp"] = "<35%",
				["b_p_knowspell"] = true,
				["v_togglename"] = "Toggle 1",
				["v_durationstartedtime"] = 0,
				["b_t_hp"] = true,
				["v_spellname"] = "114866",
				["v_keybind"] = "<keybind>",
				["v_p_bloodrunes"] = "=2",
				["b_rangecheck"] = true,
			},
		},
		["SortedActions"] = {
			"defaultRotation/deathknight/blood_presence", -- [1]
			"defaultRotation/deathknight/horn_of_winter", -- [2]
			"defaultRotation/deathknight/bone_shield", -- [3]
			"defaultRotation/deathknight/vampiric_blood", -- [4]
			"defaultRotation/deathknight/death_pact", -- [5]
			"defaultRotation/deathknight/dancing_rune_weapon", -- [6]
			"defaultRotation/deathknight/blood_tap_blood_rune", -- [7]
			"defaultRotation/deathknight/blood_tap_frost_rune", -- [8]
			"defaultRotation/deathknight/blood_tap_unholy_rune", -- [9]
			"defaultRotation/deathknight/plague_leech", -- [10]
			"defaultRotation/deathknight/outbreak", -- [11]
			"defaultRotation/deathknight/blood_boil_refresh_runic_empowerment", -- [12]
			"defaultRotation/deathknight/blood_boil_refresh", -- [13]
			"defaultRotation/deathknight/defile", -- [14]
			"defaultRotation/deathknight/death_strike", -- [15]
			"defaultRotation/deathknight/soul_reaper_runic_empowerment", -- [16]
			"defaultRotation/deathknight/soul_reaper", -- [17]
			"defaultRotation/deathknight/blood_boil_runic_empowerment", -- [18]
			"defaultRotation/deathknight/blood_boil", -- [19]
			"defaultRotation/deathknight/death_coil", -- [20]
			"defaultRotation/deathknight/blood_boil_crimson_scourge", -- [21]
		},
		["keybind"] = "<keybind>",
	},
  }

  -- Restore the true state of the saved data.
  --  return RotationBuilder:restoreTable({}, rotation);
  return rotation;
end

local deathKnightRotationsGeneratorData = {
  ["version"] = 1, 
  ["generator"] = deathKnightRotationsGenerator
};

RotationBuilder:addDefaultRotationsGenerator("DEATHKNIGHT", deathKnightRotationsGeneratorData);